package vc.thinker.mqtt.proxyclient.actor.up;

import akka.actor.AbstractActor;
import akka.japi.pf.ReceiveBuilder;
import com.alibaba.fastjson.JSONArray;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import vc.thinker.mqtt.proxyclient.ThirdPartyProxyClientProtocol;
import vc.thinker.mqtt.proxyclient.entity.up.ServiceExecResult;
import vc.thinker.mqtt.proxyclient.enums.ThirdPartyProxyTopicDefinition;

import javax.annotation.Resource;

/**
 * 拉取仪表列表
 *
 * @author HeTongHao
 * @since 2022/8/19 15:43
 */
@Slf4j
@Component
@Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ThirdPartyServiceExecuteResponseActor extends AbstractActor {
    @Resource
    private ThirdPartyProxyClientProtocol thirdPartyProxyClientProtocol;

    public ThirdPartyServiceExecuteResponseActor() {
        receive(ReceiveBuilder.match(ServiceExecResult.class, serviceExecResult ->
                thirdPartyProxyClientProtocol.sendMessage(ThirdPartyProxyTopicDefinition.executeServiceResponse
                        , serviceExecResult.getProtocolCode()
                        , JSONArray.toJSONBytes(serviceExecResult))
        ).build());
    }
}
