package vc.thinker.thirdpartyproxy.protocolimpls.test;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import vc.thinker.absctacts.protocolproxy.dto.IMeterReportEntity;
import vc.thinker.absctacts.protocolproxy.dto.MeterReportEntity;
import vc.thinker.absctacts.protocolproxy.enums.IMeterDataDefine;
import vc.thinker.absctacts.protocolproxy.enums.IProtocolType;
import vc.thinker.absctacts.protocolproxy.protocol.AbstractThirdPartyProtocol;
import vc.thinker.thirdpartyproxy.ProtocolType;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * @author HeTongHao
 * @since 2021/7/9 17:13
 */
@Slf4j
@Component
public class TestProtocol extends AbstractThirdPartyProtocol {
    @Override
    public IProtocolType protocolType() {
        return ProtocolType.test;
    }

    //    @Scheduled(cron = "* * * * * *")
    public void report() {
        super.report(MeterReportEntity.builder("001", LocalDateTime.now())
                .putValue(TestMeterAttrDefine.voltage, 111)
                .putValue(TestMeterAttrDefine.current, 100)
                .putValue(TestMeterAttrDefine.Active_energy, 123456.233)
                .putValue(TestMeterEventDefine.alert, true)
                .putValue(TestMeterEventDefine.shutdown, false)
                .build()
        );
    }

//    @Scheduled(cron = "* * * * * *")
    public void reportMulti() {
        List<IMeterReportEntity> meterReportEntityList = Lists.newArrayList();
        for (int i = 0; i < 3; i++) {
            Map<IMeterDataDefine, Object> map = Maps.newLinkedHashMap();
            map.put(TestMeterAttrDefine.current, 100);
            map.put(TestMeterAttrDefine.voltage, 111);
            map.put(TestMeterAttrDefine.Active_energy, 123456.233);
            map.put(TestMeterEventDefine.alert, true);
            map.put(TestMeterEventDefine.shutdown, false);
            meterReportEntityList.add(MeterReportEntity.builder("001", LocalDateTime.now())
                    .putValues(map)
                    .build());
        }
        super.report(meterReportEntityList);
    }
}
